#include<fstream>
#include<algorithm>
using namespace std;
int main()
{
    ifstream f1("SortMT.INP");
    ofstream f2("SortMT.OUT");
    int n,m;
    f1>>n>>m;
    int f[n][m];
    int i,j;
    for(i=0;i<n;i++)
    {
        for(j=0;j<m;j++)
        {
            f1>>f[i][j];
        }
    }
    f1.close();
    int l=f[0][0];
    int r=f[0][0];
    for(i=0;i<n;i++)
    {
        for(j=0;j<m;j++)
        {
            if(f[i][j]>l) l=f[i][j];
            if(f[i][j]<r) r=f[i][j];
        }
    }
    f2<<l<<' '<<r<<endl;
    int a[m];
    for(i=0;i<n;i++)
    {
        for(j=0;j<m;j++)
        {
            a[j]=f[i][j];

        }
        sort(a,a+m);
            for(int u=0;u<m;u++)
            {
                f2<<a[u]<<' ';
            }
            f2<<endl;
    }
    f1.close();
    f2.close();
    return 0;
}
